<template>
  <div>
    <div id="tiledMapCI"></div>
  </div>
</template>

<script>
import countryWorld from "../../../../public/json/country_allcompare.json";
import tileMap from "../../../../public/json/tiledmapap.json";
export default {
  props: ["data"],
  data() {
    return {
      mapSI: [],
      partner: [
        "AFG",
        "ARM",
        "ASM",
        "AZE",
        "COK",
        "FJI",
        "FSM",
        "GEO",
        "GUM",
        "IRN",
        "KAZ",
        "KGZ",
        "KIR",
        "MDV",
        "MHL",
        "MNP",
        "NCL",
        "NIU",
        "NRU",
        "PAK",
        "PLW",
        "PYF",
        "SLB",
        "TJK",
        "TKM",
        "TLS",
        "TON",
        "TUR",
        "TUV",
        "UZB",
        "VUT",
        "WSM",
        "PNG",
        "RUS",
        "KHM",
        "IDN",
        "PHL",
        "LAO",
        "BTN",
        "NPL",
        "BGD",
        "IND",
        "LKA",
        "MMR",
        "THA",
        "AUS",
        "NZL",
        "BRN",
        "MYS",
        "SGP",
        "VNM",
        "MAC",
        "PRK",
        "HKG",
        "MNG",
        "CHN",
        "KOR",
        "JPN",
      ],
      reporter: [],
      tiledMapCI: [],
    };
  },
  methods: {
    async ShowMap() {
      this.mapSI = tileMap;
      this.reporter = this.data;

      //cal score in the map
      let data = {
        name: "score in map",
        partner: this.partner,
        reporting: this.reporter,
        year: this.getEndYear(),
        type: "Conventional",
      };
      let url2 = this.ri_api + "economy/fivebar_top4_eco.php";
      let res2 = await axios.post(url2, JSON.stringify(data));
      let result2x = res2.data;
      let datax = [];
      this.partner.forEach((x) => {
        let scoreArray = result2x.filter((item) => item.partner == x);

        let score = 0;
        let countryCode;
        if (scoreArray.length > 0) {
          score =
            scoreArray.reduce((a, b) => a + Number(b.score), 0) /
            scoreArray.length;
          let countryCodeFilter = countryWorld.filter((y) => y.iso == x);
          if (countryCodeFilter.length > 0) {
            countryCode = countryCodeFilter[0].code;
            let scoreAdd = Number(score.toFixed(2));
            let temp = {
              country: countryCode,
              score: scoreAdd,
            };
            datax.push(temp);
          }
        }
      });

      // Reset value in Json
      this.tiledMapCI = [...tileMap];
      this.tiledMapCI.forEach((x) => {
        let dataMatch = datax.filter((y) => y.country == x.alpha2);
        if (dataMatch.length > 0) {
          x.value = dataMatch[0].score;
        } else {
          x.value = -999;
        }
      });
      let numInMap = this.tiledMapCI.map((x) => x.value);
      let numMax = Math.max(...numInMap);
      let st1Set = Number((numMax / 5).toFixed(2));
      let st2Set = Number(((numMax / 5) * 2).toFixed(2));
      let st3Set = Number(((numMax / 5) * 3).toFixed(2));
      let st4Set = Number(((numMax / 5) * 4).toFixed(2));
      let st5Set = Number(numMax.toFixed(2));
      let _this = this;
      Highcharts.chart("tiledMapCI", {
        chart: {
          type: "tilemap",
          inverted: true,
          width: "500",
          height: "500",
        },

        title: {
          text: "",
        },

        xAxis: {
          visible: false,
        },

        yAxis: {
          visible: false,
        },

        colorAxis: {
          dataClasses: [
            {
              to: 0,
              color: "#AB8A64",
              name: "No data available",
            },
            {
              from: 0,
              to: st1Set,
              color: "#C25555",
              name: "0 - " + st1Set.toFixed(2),
            },
            {
              from: st1Set,
              to: st2Set,
              color: "#E7A84A",
              name: st1Set.toFixed(2) + " - " + st2Set.toFixed(2),
            },
            {
              from: st2Set,
              to: st3Set,
              color: "#FBD49A",
              name: st2Set.toFixed(2) + " - " + st3Set.toFixed(2),
            },
            {
              from: st3Set,
              to: st4Set,
              color: "#D3CF5E",
              name: st3Set.toFixed(2) + " - " + st4Set.toFixed(2),
            },
            {
              from: st4Set,
              to: st5Set,
              color: "#65BA47",
              name: st4Set.toFixed(2) + " - " + st5Set.toFixed(2),
            },
          ],
        },

        tooltip: {
          // headerFormat: "",
          // pointFormat:
          //   "The population of <b> {point.name}</b> is <b>{point.value}</b>",
          // enabled: false,
          pointFormatter: function () {
            let result = "";
            if (this.value == -999) {
              result = "No data available for " + this.name;
            } else {
              result =
                this.name +
                "'s conventional integration score is " +
                this.value;
            }

            return result;
          },
        },

        plotOptions: {
          series: {
            dataLabels: {
              enabled: true,
              format: "{point.alpha2}",
              color: "#000000",
              style: {
                textOutline: false,
              },
            },
          },
        },
        credits: {
          enabled: false,
        },
        exporting: {
          enabled: false,
        },
        series: [
          {
            name: "",
            data: _this.tiledMapCI,
          },
        ],
      });
    },
  },
  mounted() {
    setTimeout(() => {
      this.ShowMap();
    }, 1000);
  },
  watch: {
    data: function (newData, oldData) {
      setTimeout(() => {
        this.ShowMap();
      }, 1000);
    },
  },
};
</script>

<style lang="scss" scoped></style>
